# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================
__version__= '3.4'


from Globals import HTMLFile,MessageDialog
from ImageFile import ImageFile
import SQLFormsReporter





#html-add-form
manage_addForm = HTMLFile('dtml/add_form', globals())







#action for html-add-form
def manage_add(self, id='',title='', database='',REQUEST=None, submit=None):
    """Add a SQLForm Object """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_form',)
    if database=='':
        return MessageDialog( title='Error', message='''
        Please select a database adaptor!<br>
        If no database adaptors available, please add some!
        ''', action = REQUEST['URL1']+'/add_form',)
    ob=SQLFormsReporter.SQLFormsReporterDocument(id,title,database)
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'




# Load images from disk and make them accessible
misc_={
       'up_img':         ImageFile('img/up.gif',globals()),
       'down_img':       ImageFile('img/down.gif',globals()),
       'icon':           ImageFile('img/document.gif',globals()),
      }  






def initialize(context): 
    """Initialize the product."""
    
    try: 
        context.registerClass(
            SQLFormsReporter.SQLFormsReporterDocument,
            constructors = (                 
                manage_addForm,  #html file; html-form has action next constructor
                manage_add),     #constructor caled from html-form (action)                                            
            )
        context.registerBaseClass(SQLFormsReporter.SQLFormsReporterDocument)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb

    context.registerHelp()
    context.registerHelpTitle('SQL Forms Reporter')

